<script lang="ts" setup>
	import { showConfirmDialog, showToast } from 'vant';
	import { onMounted, ref } from 'vue'
	import { deleteAction, getAction, postAction, putAction } from '../../common/http';

	const showPop = ref(false)
	const list = ref([] as any[])
	const form = ref({} as any)

	onMounted(() => {
		init()
	})
	const init = () => {
		getAction('/blemish').then((res : any) => {
			if (res.code === 200) {
				list.value = res.data
			}
		})
	}

	const onClickLeft = () => {
		history.back()
	}
	const onClickRight = () => {
		form.value = {}
		showPop.value = true
	}
	const edit = (item : any) => {
		form.value=JSON.parse(JSON.stringify(item))
		showPop.value = true
	}
	const onSubmit = () => {
		if (form.value.id) {
			putAction('/blemish', form.value).then((res : any) => {
				if (res.code === 200) {
					init()
					showPop.value = false
					showToast('提交成功！')
				}
			})
		} else {
			postAction('/blemish', form.value).then((res : any) => {
				if (res.code === 200) {
					init()
					showPop.value = false
					showToast('提交成功！')
				}
			})
		}
	}

	const del = (item : any) => {
		showConfirmDialog({
			title: '提示',
			message: '是否确认删除？',
		}).then(() => {
			let url = '/blemish/' + item.id
			deleteAction(url).then((res : any) => {
				if (res.code === 200) {
					init()
					showToast('删除成功！')
				}
			})
		})
			.catch(() => {
				// on cancel
			});
	}
</script>

<template>
	<view class="flex">
		<van-nav-bar title="色胚质检瑕疵维护" left-text="返回" left-arrow right-text="新增" @click-left="onClickLeft"
			@click-right="onClickRight" />
		<view class="content">
			<view class="grid-container">
				<view class="grid-item">编号</view>
				<view class="grid-item">瑕疵名称</view>
				<view class="grid-item">操作</view>
			</view>
			<view class="grid-container" v-for="(item,index) in list" :key="index">
				<view class="grid-item">{{item.id}}</view>
				<view class="grid-item">{{item.name}}</view>
				<view class="grid-item"><span style="color: #35a5f7" @click="edit(item)">编辑</span> &nbsp;&nbsp; <span
						style="color: red" @click="del(item)">删除
					</span></view>
			</view>
		</view>
	</view>

	<van-popup v-model:show="showPop" style="width: 80%" round>
		<view>
			<h3 style="text-align: center">{{form.id?'编辑':'新增'}}</h3>
			<van-form @submit="onSubmit">
				<van-cell-group inset>
					<van-field v-model="form.name" name="瑕疵名称" label="瑕疵名称" colon label-width="5em"
						:rules="[{ required: true, message: '请填写' }]" />
				</van-cell-group>
				<view class="a-c">
					<van-button type="danger" @click="showPop=false">取消</van-button>
					<van-button type="primary" native-type="submit">确认</van-button>
				</view>
			</van-form>
		</view>
	</van-popup>
</template>

<style scoped lang="scss">
	.flex {
		display: flex;
		flex-direction: column;
		height: 100vh;
		width: 100vw;

		.van-nav-bar {
			width: 100%;
		}

		.content {
			flex: 1;
			padding: 0 20rpx;

			.grid-container {
				display: grid;
				grid-template-columns: 1fr 3fr 2fr;

				.grid-item {
					border: 1rpx solid #f2f2f2;
					text-align: center;

					::v-deep(.van-cell) {
						padding: 0 10rpx;
					}
				}
			}

			.card {
				margin: 20rpx 30rpx;
				padding: 10rpx;
				border: 1rpx solid #02a7f0;
				border-radius: 20rpx;
			}
		}
	}

	.grid-container1 {
		display: grid;
		grid-template-columns: 2fr 1fr;

		.grid-item {
			border: 1rpx solid #f2f2f2;
			text-align: center;
			padding: 10rpx 0;
		}
	}

	.a-b {
		margin: 10rpx;

		::v-deep .van-button--normal {
			padding: 5px 8px;
			height: 30px;
		}
	}

	::v-deep .van-field {
		font-size: 16px;
	}

	::v-deep .van-field__control {
		border-bottom: 1rpx solid #d7d7d7;
		text-align: center;
		font-size: 16px;
	}

	::v-deep .van-field__label {
		text-align: end !important;
	}

	.b-a {
		::v-deep .van-field__control {
			border-bottom: none;
		}
	}

	.a-c {
		display: flex;
		align-items: center;
		justify-content: space-around;
		margin: 30rpx;

		::v-deep .van-button--normal {
			padding: 10rpx !important;
			height: 60rpx;
		}
	}
</style>